#!/bin/sh

set -x

panic() {
	echo $1
	exit 1
}

do_fusing() {
	[ -b $1 ] || panic "Invalid block device"
	[ "x$2" = "x" ] && panic "No target device"

	if [ -d /sys/block/${1##*/}boot0 ]; then
		echo "$1 is an eMMC card, disabling ${1##*/}boot0 ro"
		echo -n 0 | tee /sys/block/${1##*/}boot0/force_ro || \
			panic"Enabling r/w for $1boot0 failed"
		bl1_position=0
		bl2_position=30
		uboot_position=62
		tzsw_position=2110
		device=$1boot0
	else
		bl1_position=1
		bl2_position=31
		uboot_position=63
		tzsw_position=2111
		device=$1
	fi

	dd iflag=dsync oflag=dsync if=$2/bl1.bin.hardkernel of=$device seek=$bl1_position
	dd iflag=dsync oflag=dsync if=$2/bl2.bin.hardkernel.1mb_uboot of=$device seek=$bl2_position
	dd iflag=dsync oflag=dsync if=$2/tzsw.bin.hardkernel of=$device seek=$tzsw_position
	dd iflag=dsync oflag=dsync if=$2/u-boot.bin of=$device seek=$uboot_position

	echo "U-boot image is fused successfully."
}
